package com.sun.appserver.tests.ha.sfsb.sfbtc38;
import javax.ejb.Stateful;
import javax.ejb.EJB;
import javax.ejb.EJBs;
import javax.ejb.Remove;
import javax.ejb.EJBException;
import javax.ejb.SessionContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionAttribute;
import java.util.Vector;

import javax.naming.InitialContext;

import javax.annotation.Resource;
import javax.transaction.UserTransaction;
@Stateful
@TransactionManagement(TransactionManagementType.BEAN)
public class SFBTC38BMTBean implements SFBTC38BMT {
	   private @Resource SessionContext context;


	String customerName;
	//String customerId;
	Vector contents;
	UserTransaction ut = null; 
@Remove
   public void remove() {
        System.out.println("Successfully Executed remove()");}

	 /**
       	  * Creates a bean.
          * @param person name of the customer.
          * @exception throws CreateException, RemoteException.
          */

	public void ejbCreate(String person) throws Exception {

		if (person == null) {
			throw new Exception("Null person not allowed.");
		} else {
			customerName = person;
		}
		
	//	customerId = "0";
		contents = new Vector();
	}

	public String getId() {
		return customerName;
		}

    /**
     * Adds a book to the cart.
     * @param title title of the book.
     * @exception RemoteException
     */
	public void addBook(String title) {	

	// UserTransaction start here
        try {
            // Lookup the UserTransaction object
            ut = (UserTransaction) context.getUserTransaction();
            ut.begin();         // start the transaction.
            System.out.println("BMT : UserTransaction started");
	    contents.addElement(title);
	    System.out.println("Book Added in BMT Bean");
	    ut.commit(); 	// Commit the transaction. 
	    System.out.println("BMT : UserTransaction commited");

	} catch (Exception e) {
            e.printStackTrace();
            }
// UserTransaction start code end here
	}
	
    /**
     * Removes a book from the cart.
     * @param title title of the book.
     * @exception RemoteException, BookException
     */
	public void removeBook(String title) throws Exception {
		boolean result = contents.removeElement(title);
		if (result == false) {
			throw new Exception(title + " not in cart.");
		}
	}

    /**
     * Gets the content.
     * @return Vector containing books.
     * @exception RemoteException
     */
	public Vector getContents() {
		return contents;
	}


} 
