package com.sun.appserver.tests.ha.sfsb.sfbtc38;
import javax.ejb.Stateful;
import javax.ejb.EJB;
import javax.ejb.EJBs;
import javax.ejb.Remove;
import javax.ejb.EJBException;
import javax.ejb.SessionContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionAttribute;
import java.util.Vector;

import javax.naming.InitialContext;

import javax.annotation.Resource;
import javax.transaction.UserTransaction;
@Stateful
@TransactionManagement(TransactionManagementType.BEAN)

public class SFBTC38Bean implements SFBTC38 {

	String customerName;
	Vector contents;
	@EJB	SFBTC38CMT sfbtc38c;
	SFBTC38CMT sfbtc38cmt;
	@EJB    SFBTC38BMT sfbtc38b;
	SFBTC38BMT  sfbtc38bmt;
@Remove	
   public void remove() {
        System.out.println("Successfully Executed remove()");}



	public void ejbCreate(String person) throws Exception {

		if (person == null) {
			throw new Exception("Null person not allowed.");
		} else {
			customerName = person;
		}
		
		contents = new Vector();
	}

	public String getId() {
		return customerName;
		}

	public void addBook(String title)  {	
	try {
	    contents.addElement(title);
	    System.out.println("Book Added in 1st Bean");
            sfbtc38cmt = getCMTObject(); 
		sfbtc38cmt.ejbCreate("MyCMTBean");
	    sfbtc38cmt.addBook("Book Added in CMT Bean");
	    sfbtc38bmt = getBMTObject();
	      sfbtc38bmt.ejbCreate("MyCMTBean");
            sfbtc38bmt.addBook("Book Added in BMT Bean");
	}catch (Exception ex) {
			ex.printStackTrace();
	}

	}
	
	public SFBTC38CMT getCMTObject() {
		return sfbtc38c; 
	}	

        public SFBTC38BMT getBMTObject() {
        	return sfbtc38b;
        }


    /**
     * Removes a book from the cart.
     * @param title title of the book.
     * @exception RemoteException, BookException
     */
	public void removeBook(String title) throws Exception {
		boolean result = contents.removeElement(title);
		if (result == false) {
			throw new Exception(title + " not in cart.");
		}
	}

    /**
     * Gets the content.
     * @return Vector containing books.
     * @exception RemoteException
     */
	public Vector getContents() {
		return contents;
	}

	public Vector getCMTContents() {
        	return sfbtc38cmt.getContents();
        }

	 public Vector getBMTContents() {
                return sfbtc38bmt.getContents();
        }

    /**
     * Removes the bean. Required by EJB spec.
     */
	public void ejbRemove() {}

    /**
     * Loads the state of the bean from secondary storage. Required by EJB spec.
     */
	public void ejbActivate() {}

    /**
     * Keeps the state of the bean to secondary storage. Required by EJB spec.
     */
	public void ejbPassivate() {}

    /**
     * Sets the session context. Required by EJB spec.
     * @param ctx A SessionContext object.
     */
	public void setSessionContext(SessionContext sc) {}

} 
