package com.sun.appserver.tests.ha.sfsb.sfbtc38;
import javax.ejb.Stateful;
import javax.ejb.EJB;
import javax.ejb.EJBs;
import javax.ejb.Remove;
import javax.ejb.EJBException;
import javax.ejb.SessionContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionAttribute;
import java.util.Vector;
import javax.naming.InitialContext;

import javax.annotation.Resource;
import javax.transaction.UserTransaction;
@Stateful
@TransactionManagement(TransactionManagementType.CONTAINER)

public class SFBTC38CMTBean implements SFBTC38CMT {

	String customerName;
	Vector contents;


	 /**
       	  * Creates a bean.
          * @param person name of the customer.
          * @exception throws CreateException, RemoteException.
          */
@Remove
   public void remove() {
        System.out.println("Successfully Executed remove()");}

@TransactionAttribute(TransactionAttributeType.REQUIRED)


	public void ejbCreate(String person) throws Exception {

		if (person == null) {
			throw new Exception("Null person not allowed.");
		} else {
			customerName = person;
		}
		
	//	customerId = "0";
		contents = new Vector();
	}
@TransactionAttribute(TransactionAttributeType.REQUIRED)

	public String getId() {
		return customerName;
		}
@TransactionAttribute(TransactionAttributeType.REQUIRED)

	public void addBook(String title) {	
	    contents.addElement(title);
	    System.out.println("Book Added in CMT Bean");
	}
	
    /**
     * Removes a book from the cart.
     * @param title title of the book.
     * @exception RemoteException, BookException
     */
@TransactionAttribute(TransactionAttributeType.REQUIRED)

	public void removeBook(String title) throws Exception {
		boolean result = contents.removeElement(title);
		if (result == false) {
			throw new Exception(title + " not in cart.");
		}
	}

    /**
     * Gets the content.
     * @return Vector containing books.
     * @exception RemoteException
     */
@TransactionAttribute(TransactionAttributeType.REQUIRED)

	public Vector getContents() {
		return contents;
	}


} 
